# プレセミナー第２回
# R言語を使ってみよう

# P2.1	数値，演算，論理値

# 数値演算
10^2
sqrt(100)
exp(30)
exp(-30)

# 比較演算
1 < 3
1 > 3
1 == 3
1 != 3

# 論理演算
TRUE & TRUE
TRUE & FALSE
TRUE | TRUE
TRUE | FALSE
FALSE | FALSE

!TRUE
!FALSE
T
F

# P2.2	変数とオブジェクト

x <- 5
x = 5
x
x <- 1 + 1
(x <- 1 + 1)
x * 3
x
x <- x * 3
A <- 10
A

# P2.3	ベクトル
# P2.3.1	数値ベクトル

# ベクトルの作り方
(x <- c(1,2,3,4,5))
x * 3
3 * x
y <- c(1,1,3,5,5)
x * y
length(x)
5:20
seq(5,20)
seq(5,20,1.5)
rep(5,10)
100:200
(z <- 2 + 3)
length(z)


# 数値ベクトルに関する関数
x <- c(2.3,3.4,0.7,1.3,2.8)
sum(x)
sum(x)/length(x)
mean(x)
median(x)
sum((x-mean(x))^2)/(length(x)-1)
var(x)
sd(x)
max(x)
min(x)
range(x)

# P2.3.2	文字列ベクトル

(x <- c("apple","orange","strawberry"))
rep("apple",5)
(y <- c("1","2","3","4","5"))
class(y)
class(1:5)
class(c(1.5,2.0,2.5))

# P2.3.3	論理ベクトル

y <- c(FALSE,TRUE,TRUE)
y

y <- c(F,T,T)
y

# P2.4	ベクトルの成分へのアクセス
# P2.4.1	番号によるアクセス

(x <- 5:10)
x[1]
x[3]
x[3] <- 0
x
x[c(2,4)]
x[1:3]
x[c(-2,-4)]
x[-c(2,4)]

# P2.4.2	論理ベクトルによるアクセス

x[c(T,F,T,F,T,F)]
x > 5
y <- x > 5
x[y]
x[x>5]
sum(x>5)

# P2.4.3	名前によるアクセス

(price <- c(148, 98, 398))
names(price)
names(price) <- c("apple","orange","strawberry")
price
names(price)
price["orange"]
price[c("apple","strawberry")]

# P2.5	関数について

rep("apple",5)
rep(x = "apple", times = 5)
rep(times = 5, x = "apple")
?rep

# P2.6	データフレーム

iris
head(iris)
class(iris)
rownames(iris)
colnames(iris)
iris$Sepal.Length
class(iris$Sepal.Length)
summary(iris)
boxplot(iris)
x <- c("A","B","C")
y <- c(3,5,7)
(df1 <- data.frame(x,y))
df2 <- data.frame(col1=x,col2=y)
df2
nrow(df2)
ncol(df2)
dim(df2)
(df3 <- cbind(df1,df2))
dim(df3)
# エラーが出る
df4 <- rbind(df1,df2)
rbind(df1,df1)


# P2.7	データフレームの行，列，成分へのアクセス
# P2.7.1	番号によるアクセス

df5 <- iris
head(df5)
df5[1,1]
df5[4,2]
df5[4,2] <- 5.9
head(df5)
df5[2,]
df5[,3]
df5[4:8,-5]

# P2.7.2	論理ベクトルによるアクセス
df5 <- iris
df6 <- df5[df5$Sepal.Length >= 6,]
summary(df6)
df5[df5$Species == "versicolor",]
df5[(df5$Species == "versicolor") & (df5$Sepal.Length >= 6),]

# P2.7.3	名前によるアクセス

df5["3","Petal.Length"]
df5[c("3","5"),c("Petal.Length","Petal.Width")]
df5[df5$Sepal.Length >= 6,c("Petal.Length","Petal.Width")]
subset(df5, Sepal.Length >= 6, c("Petal.Length", "Petal.Width"))

# P2.8	行列

# エラーが出る
heatmap(x = iris[,-5])
(mt1 <- as.matrix(iris[,-5]))
class(mt1)
heatmap(x = mt1)
(mt2 <- as.matrix(iris)[,-5])
# エラーが出る
heatmap(x = mt2)
dim(mt1)
(mt3 <- t(mt1))
dim(mt3)
mt4 <- t(iris[,-5])

# P2.9	リスト

ability.cov
class(ability.cov)
ability.cov$cov
ability.cov$center
ability.cov$n.obs
class(ability.cov$cov)

# P2.10	大規模データ解析用パッケージについて

install.packages("data.table")
library(data.table)

# P2.11	課題

head(mtcars)
dim(mtcars)
