# プレセミナー第３回
# R言語でプログラミングしよう

# P3.2	制御構文

# P3.2.1 for構文による繰り返し

# for構文
for(i in 1:5) print(i)

x <- c(1,2,3,4,5)

for(i in x) print(i)

# 文字列ベクトルに対しても同様にfor構文が使える
for(item in c("apple","orange","strawberry")) print(item)

# 複数の処理を行う場合には、{}で囲む
for(i in 1:5){
  j <- 1:i
  print(j)
}

# P3.2.2 if構文による条件分岐

x <- 78

# if構文
if( x >= 60 ) print("合格") else print("不合格")

x <- 53

# 同一のif構文でもxの値によって結果が変わる
if( x >= 60 ) print("合格") else print("不合格")

scores <- c(75,43,89,93,51)

# if構文とfor構文を組み合わせた例
for(x in scores) {
  print(x)
  if( x >= 60 ) print("合格") else print("不合格") 
}

x <- 78

# ifelse関数
ifelse(x>=60,"合格","不合格")

# ifelse関数は、ベクトルに対して用いると便利
ifelse(scores >= 60,"合格","不合格")
results <- ifelse(scores >= 60,"合格","不合格")
data.frame(scores,results)

# P3.3 関数の作成

x <- c(2.3,3.4,0.7,1.3,2.8)

# 分散の定義通りに計算
sum((x-mean(x))^2)/(length(x)-1)

# 自分で分散を計算する関数を定義する
my_var <- function(x) sum((x-mean(x))^2)/(length(x)-1)

my_var(x)
var(x)

y <- 1:10
my_var(y)
my_var(1:10)
var(y)

# 複数行にわたる処理として、関数を定義
my_var <- function(x) {
  a <- sum((x-mean(x))^2)
  b <- (length(x)-1)
  return(a/b)
}

my_var

#P3.4 データの読み込みと保存

# 現在の作業ディレクトリを確認
getwd()

# lung50.csvが作業ディレクトリに保存してある必要がある
df <- read.csv("lung50.csv")

class(df)
head(df)

getwd()

# user_nameのところは各自のアカウント名に変更する。
setwd("C:/Users/user_name")

getwd()

# irisデータをcsvとして保存
write.csv(iris,"iris.csv")

# P3.5 データの並べ替え

x <- c(4.5, 12.0, 9.3, 11.1, 3.6)
sort(x)
sort(x,decreasing=T)

order(x)
x[5]
x[1]
x[order(x)]
x[c(5,1,3,4,2)]
order(x,decreasing=T)
x[order(x,decreasing=T)]

o <- order(iris$Sepal.Length)
iris[o,]
iris[order(iris$Sepal.Length),]
iris[order(iris$Sepal.Width,decreasing=T),]
